<?php
/*
Plugin Name: Multi Settings Parameters
Description: Allows use of global settings variables with Tabs.
Version: 1.0.0
Author: Naviga Web Team
Author URI: #
*/
// use the registered jquery and style above
namespace Everyware\Plugin\MultiSettingsParameters;
class MultiSetingsParametersPlugin
{
    function __construct()
    {
        add_action('admin_menu', array($this, 'adminPage'));
        add_action('admin_head', array($this, 'register_script'));
        add_action('wp_ajax_nopriv_msp_action', array($this, 'msp_action_fun'));
        add_action('wp_ajax_msp_action', array($this, 'msp_action_fun'));
        add_action('wp_ajax_nopriv_msp_import_action', array($this, 'msp_import_action_fun'));
        add_action('wp_ajax_msp_import_action', array($this, 'msp_import_action_fun'));
        add_action('wp_ajax_nopriv_msp_export_action', array($this, 'msp_export_action_fun'));
        add_action('wp_ajax_msp_export_action', array($this, 'msp_export_action_fun'));
        add_action('wp_ajax_nopriv_msp_action_delete', array($this, 'msp_action_delete'));
        add_action('wp_ajax_msp_action_delete', array($this, 'msp_action_delete'));
    }

    function register_script()
    {
        wp_enqueue_script('ajax_jquery', "https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js");
        wp_enqueue_style('bootstarp', "https://stackpath.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css");
        wp_enqueue_script('bootstrap_jquery', "https://stackpath.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js");
        wp_enqueue_script('custom_jquery', plugins_url('/assets/js/main.js', __FILE__), array('jquery'), '2.5.1');
        wp_enqueue_style('new_style', plugins_url('/assets/css/style.css', __FILE__));
    }
    function adminPage()
    {
        add_options_page('Multi Settings Parameters', 'Multi Settings Parameters', 'manage_options', 'multi-settings-parameters-page', array($this, 'ourHTML'));
    }

    function ourHTML()
    {
        require_once 'src/main.php';
    }

  
    /**
     * Ajax parameters save.
     *
     **/

    function msp_action_fun()
    {
        $val = json_decode(stripslashes($_POST['valed']));        
        $kye = json_decode(stripslashes($_POST['kyed']));
        $tbname = "ewmspparam_" . trim($_POST['tbname']);

        $oneDim = array();
        $i = 0;
        foreach ($kye as $k) {
            $oneDim[$k] = $val[$i];
            $i++;
        }
        if( update_option($tbname, serialize($oneDim)) )
            die(true);
        die(false);    
    }

     /**
     * Ajax import parameters save.
     *
     **/

    function msp_import_action_fun()
    {
        $tbname = "ewmspparam_" . trim($_POST['tbname']);
        $oldvals = get_option($tbname);
        $oldvalsarr = unserialize($oldvals);
        if (isset($_POST['kyed'])) {
            $ipkye = stripslashes(html_entity_decode($_POST['kyed']));
            $importedParameters = json_decode($ipkye, true);
            $iparr = [];
            $i = 0;
            foreach ($importedParameters as $Ky => $ip) {
                $iparr[$ip["key"]] = $ip["value"];
            }
            if (!empty($oldvalsarr)) {
                $finalData = serialize(array_merge($oldvalsarr, $iparr));
            } else {
                $finalData = serialize($iparr);
            }
            if (update_option($tbname, $finalData)) {
                die(true);
            } else {
                die(false);
            }
        }
    }

     /**
     * Ajax export parameters save.
     *
     **/

    function msp_export_action_fun()
    {
        $tbname = trim($_POST['tbname']);
        $vat = get_option($tbname);        
        $achiver = unserialize($vat);
        $arr = [];
        $i = 0;
        foreach ($achiver as $ach => $val) {
            $arr[$i]['key'] = $ach;
            $arr[$i]['value'] = $val;
            $i++;
        }        
        $jsonvalue = json_encode($arr);
        die($jsonvalue);
    }

   /**
     * Tab delete.
     *
     **/
    function msp_action_delete()
    {
        $valm = $tbname = "ewmspparam_" . trim($_POST['tbname']);
        if (delete_option($valm))
            return TRUE;
        else
            return FALSE;
    }
   public static function multi_settings_parameter($tbname, $key)
   {
      $tbname = "ewmspparam_".strtolower(trim(str_replace(' ', '_', $tbname)));
      $tbval = get_option($tbname);
      $tbvalarr = unserialize($tbval);
      return $tbvalarr[$key]??null;
   } 
} // class closed here
$multiSetingsParametersPlugin = new MultiSetingsParametersPlugin();

?>